# -*- coding: utf-8 -*-
"""
Created on Wed Jul 21 12:24:23 2021

@author: Dohmen
"""

# http://physics.nist.gov/cgi-bin/Compositions/stand_alone.pl
masses = {
    'x': 0.000,
    '1H': 1.0078503223,
    '2H': 2.01410177812,
    '2D': 2.01410177812,
    'D': 2.01410177812,
    'H': 1.0078503223,
    '4He': 4.00260325413,
    'He': 4.00260325413,
    '6Li': 6.0151228874,
    '7Li': 7.0160034366,
    'Li': 7.0160034366,
    '9Be': 9.012183065,
    'Be': 9.012183065,
    '10B': 10.01293695,
    '11B': 11.00930536,
    'B': 11.00930536,
    '12C': 12.00000000,
    '13C': 13.00335483507,
    'C': 12.00000000,
    '14N': 14.00307400443,
    '15N': 15.00010889888,
    'N': 14.00307400443,
    '16O': 15.99491461957,
    '18O': 17.99915961286,
    'O': 15.99491461957,
    '19F': 18.99840316273,
    'F': 18.99840316273,
    '20Ne': 19.9924401762,
    '21Ne': 20.993846685,
    '22Ne': 21.991385114,
    'Ne': 19.9924401762,
    '23Na': 22.9897692820,
    'Na': 22.9897692820,
    '24Mg': 23.985041697,
    '25Mg': 24.985836976,
    '26Mg': 25.982592968,
    'Mg': 23.985041697,
    '27Al': 26.98153853,
    'Al': 26.98153853,
    '28Si': 27.97692653465,
    '29Si': 28.97649466490,
    '30Si': 29.973770136,
    'Si': 27.97692653465,
    '31P': 30.97376199842,
    'P': 30.97376199842,
    '32S': 31.9720711744,
    '33S': 32.9714589098,
    '34S': 33.967867004,
    'S': 31.9720711744,
    '35Cl': 34.968852682,
    '37Cl': 36.965902602,
    'Cl': 34.968852682,
    '40Ar': 39.9623831237,
    '36Ar': 35.967545105,
    'Ar': 39.9623831237,
    '39K': 38.9637064864,
    '41K': 40.9618252579,
    'K': 38.9637064864,
    '40Ca': 39.962590863,
    '42Ca': 41.95861783,
    '44Ca': 43.95548156,
    'Ca': 39.962590863,
    '45Sc': 44.95590828,
    'Sc': 44.95590828,
    '48Ti': 47.94794198,
    '46Ti': 45.95262772,
    '47Ti': 46.95175879,
    'Ti': 47.94794198,
    '51V': 50.94395704,
    '50V': 49.94715601,
    'V': 50.94395704,
    '50Cr': 49.94604183,
    '52Cr': 51.94050623,
    '53Cr': 52.94064815,
    '54Cr': 53.93887916,
    'Cr': 51.94050623,
    '55Mn': 54.93804391,
    'Mn': 54.93804391,
    '56Fe': 54.93804391,
    '54Fe': 53.93960899,
    '57Fe': 56.93539284,
    'Fe': 54.93804391,
    '59Co': 58.93319429,
    'Co': 58.93319429,
    '58Ni': 57.93534241,
    '60Ni': 59.93078588,
    '62Ni': 61.92834537,
    'Ni': 57.93534241,
    '63Cu': 62.92959772,
    '65Cu': 64.92778970,
    'Cu': 62.92959772,
    '64Zn': 63.92914201,
    '66Zn': 65.92603381,
    '67Zn': 66.92712775,
    '68Zn': 67.92484455,
    'Zn': 63.92914201,
    '69Ga': 68.9255735,
    '71Ga': 70.92470258,
    'Ga': 68.9255735,
    '70Ge': 69.92424875,
    '71Ge': 71.922075826,
    '73Ge': 72.923458956,
    '74Ge': 73.921177761,
    '76Ge': 75.921402726,
    'Ge': 73.921177761,
    '75As': 74.92159457,
    'As': 74.92159457,
    '76Se': 75.919213704,
    '77Se': 76.919914154,
    '78Se': 77.91730928,
    '80Se': 79.9165218,
    '82Se': 81.9166995,
    'Se': 79.9165218,
    '79Br': 78.9183376,
    '81Br': 80.9162897,
    'Br': 78.9183376,
    '80Kr': 79.91637808,
    '82Kr': 81.91348273,
    '83Kr': 82.91412716,
    '84Kr': 83.9114977282,
    '86Kr': 85.9106106269,
    'Kr': 83.9114977282,
    '85Rb': 84.9117897379,
    '87Rb': 86.9091805310,
    'Rb': 84.9117897379,
    '86Sr': 85.9092606,
    '87Sr': 86.9088775,
    '88Sr': 87.9056125,
    'Sr': 87.9056125,
    '89Y': 88.9058403,
    'Y': 88.9058403,
    '90Zr': 89.9046977,
    '91Zr': 90.9056396,
    '92Zr': 91.9050347,
    '94Zr': 93.9063108,
    'Zr': 89.9046977,
    '93Nb': 92.9063730,
    'Nb': 92.9063730,
    '92Mo': 91.90680796,
    '95Mo': 94.90583877,
    '96Mo': 95.90467612,
    '98Mo': 97.90540482,
    'Mo': 97.90540482,
    '97Tc': 96.9063667,
    '98Tc': 98.9062508,
    '99Tc': 98.9062508,
    'Tc': 98.9062508,
    '99Ru': 98.9059341,
    '100Ru': 99.9042143,
    '101Ru': 100.9055769,
    '102Ru': 101.9043441,
    '104Ru': 103.9054275,
    'Ru': 101.9043441,
    '103Rh': 102.9054980,
    'Rh': 102.9054980,
    '104Pd': 103.9040305,
    '105Pd': 104.9050796,
    '106Pd': 105.9034804,
    '108Pd': 107.9038916,
    '110Pd': 109.90517220,
    'Pd': 105.9034804,
    '107Ag': 106.9050916,
    '109Ag': 108.9047553,
    'Ag': 106.9050916,
    '110Cd': 109.90300661,
    '111Cd': 110.90418287,
    '112Cd': 111.90276287,
    '113Cd': 112.90440813,
    '114Cd': 113.90336509,
    'Cd': 113.90336509,
    '113In': 112.90406184,
    '115In': 114.903878776,
    'In': 114.903878776,
    '116Sn': 115.90174280,
    '118Sn': 117.90160657,
    '120Sn': 119.90220163,
    'Sn': 119.90220163,
    '121Sb': 120.9038120,
    '123Sb': 122.9042132,
    'Sb': 120.9038120,
    '126Te': 125.9033109,
    '128Te': 127.90446128,
    '130Te': 129.906222748,
    'Te': 129.906222748,
    '127I': 126.9044719,
    'I': 126.9044719,
    '129Xe': 128.9047808611,
    '131Xe': 130.90508406,
    '132Xe': 131.9041550856,
    '134Xe': 133.90539466,
    '136Xe': 135.907214484,
    'Xe': 131.9041550856,
    '194Pt': 193.9626809,
    '195Pt': 194.9647917,
    '196Pt': 195.96495209,
    'Pt': 194.9647917,
    '197Au': 196.96656879,
    'Au': 196.96656879,
    '198Hg': 197.96676860,
    '199Hg': 198.96828064,
    '200Hg': 199.96832659,
    '201Hg': 200.97030284,
    '202Hg': 201.97064340,
    'Hg': 201.97064340,
    '203Tl': 202.9723446,
    '205Tl': 204.9744278,
    'Tl': 204.9744278,
    '204Pb': 203.9730440,
    '206Pb': 205.9744657,
    '207Pb': 206.9758973,
    '208Pb': 207.9766525,
    'Pb': 207.9766525,
    '209Bi': 208.9803991,
    'Bi': 208.9803991
}

mass2label = {v: k for k, v in masses.items()}


def nearest_key(search_key):
    label = mass2label.get(search_key) or mass2label[
        min(mass2label.keys(), key=lambda key: abs(key - search_key))]
    return label

AtomicNum = {
    'x': 0,
    'H': 1,
    'He': 2,
    'Li': 3,
    'Be': 4,
    'B': 5,
    'C': 6,
    'N': 7,
    'O': 8,
    'F': 9,
    'Ne': 10,
    'Na': 11,
    'Mg': 12,
    'Al': 13,
    'Si': 14,
    'P': 15,
    'S': 16,
    'Cl': 17,
    'Ar': 18,
    'K': 19,
    'Ca': 20,
    'Sc': 21,
    'Ti': 22,
    'V': 23,
    'Cr': 24,
    'Mn': 25,
    'Fe': 26,
    'Co': 27,
    'Ni': 28,
    'Cu': 29,
    'Zn': 30,
    'Ga': 31,
    'Ge': 32,
    'As': 33,
    'Se': 34,
    'Br': 35,
    'Kr': 36,
    'Rb': 37,
    'Sr': 38,
    'Y': 39,
    'Zr': 40,
    'Nb': 41,
    'Mo': 42,
    'Tc': 43,
    'Ru': 44,
    'Rh': 45,
    'Pd': 46,
    'Ag': 47,
    'Cd': 48,
    'In': 49,
    'Sn': 50,
    'Sb': 51,
    'Te': 52,
    'I': 53,
    'Xe': 54,
    'Pt': 78,
    'Au': 79,
    'Hg': 80,
    'Tl': 81,
    'Pb': 82,
    'Bi': 83
}

AtomicNum2label = {v: k for k, v in AtomicNum.items()}

BaileyConversion = {'B': 40.85,
                    'Cl': -19.166,
                    'Br': 330.4,
                    'N': 19.40}